'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'III    BASIC++  DEMO ZUM BASIC-COMPUTER UNIT MICRO             IIIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'--------------------------------------------------------------------
' Beispiel zum BASIC-COMPUTER   und Zubehr
'--------------------------------------------------------------------
' ANWENDUNG:    4 DIGIT IIC-BUS LED-DISPLAY 198344   (TREIBER SAA1064)
'
'--------------------------------------------------------------------
' Einer der vielen erhltlichen Bausteine mit IIC-Bus
' Interface ist der 4 DIGIT LED DISPLAY TREIBER SAA1064. Er ist der Baustein
' der die 4 DIGIT 7 SEGMENTANZEIGE der LED-Anzeige ansteuert.
' Er hat ein verhltnismssig einfaches Protokoll das auch in BASIC
' recht einfach in die Treibersoftware fr diesn Baustein umgesetzt werden kann.
'
' <START><ADDRESS><INSTRUCTION><CONTROL><DIGIT1><DIGIT2><DIGIT3>DIGIT<4><STOP>
'
' Die Adresse besteht aus einem festen, nicht vernderbaren Anteil und
' einem vom Benutzer whlbaren Teil (zwei Bits). Das letzte Bit
' legt fest ob eine READ (Eingabe) oder WRITE (Ausgabe) ber den SAA1064
' erfolgt
' In diesem Beispiel hat der SAA1064 die Adresse 3 (alle Bits auf HI),
' alle Jumper abgezogen.
' Allerdings ist beim diesem Baustein die interne Adressdecodierung 
' etwas anders als blich. Das Modul hat deshalb 4 Jumper die dem
' Modul die Adresse 0 bis 3 zuweisen.
' Es darf jeweils nur ein Jumper gesteckt sein.
' J1   A0=0, A1=0
' J2   A0=1, A1=0
' J3   A0=0, A1=1
' J4   A0=1, A1=1
' Damit ergibt sich fr eine READ-Operation folgender Wert:
'
' 0 1 1 1 0 x x 1       READ-Operation
' I------I-----I-I
' FIX ADR  ADR  R/W
'
' Fr eine WRITE-Operation ist das letzte Bit LO und es ergibt sich
' folgender Wert:
'
' 0 1 1 1 0 x x 0       WRITE-Operation
' I------I-----I-I
' FIX ADR  ADR  R/W
'
' x sind die mit Jumper auf 0 setzbaren Adressbits.
' In diesem Beispiel wird angenommen, dass kein Jumper gesteckt ist. Die
' Adresse ist damit 118= $76 = 01110110

' Das INSTRUCTION-BYTE legt fest mit welches der internen Register
' zuerst beschriebnen wird. In unserem Beispiel ist das INSTRUCTION BYTE
' Null, das bedeutet dass nach dem INSTRUCTION BYTE das KONTROLLREGISTER
' und danach die DATENREGISTER der vier Digits beschrieben werden.
' Das KONTROLLREGISTER legt den LED Modus (hier Multiplex)und die LED
' Helligkeit fest.
'
' Die Zuweisung der Segmente zum jeweiligen Bit sind so:
'        a
'      f   b              xgfedcba (a=bit0)
'        g
'      e   c
'        d
' Beispiel:
' Eine 1 wird durch die Segmente bc dargestellt und die entsprechenden Bits sind
' log 1, die anderen 0 -> 00000110 =&H06
'
' Um Ihnen die Arbeit mit dem Treiber zu vereinfachen
' brauchen Sie sich aber um diese Angelegenheiten nicht zu kmmern,
' da enstprechende Unterprogramme im Treiber vorhanden sind.
'-----------------------------------------------------------------------
' SCHNITTSTELLE ZUM TREIBER
' Der Treiber fr das Display wird importiert
' Ihre Schnittstelle zum LED Treiber ist die Adresse ADDR, die Variable 
' BRIGHTNES der Sie die vordefinierten Werte BRIGHT0 bis BRIGHT7 zuweisen knnnen
' und die Variablen DIGIT1 bis DIGIT4, die alle zusammen an die
' FUNCTION SENDBUF bergeben werden. Diese FUNCTION sendet den
' Buffer zum LCD.
' Der Treiber beinhaltet auch Tabellen fr die Definition BRIGHT0-BRIGHT7,
' und fertige FUNCTIONS fr die Ausgabe von kurzen Status-Mitteilungen.
' Diesen FUNCTIONS wird als Parameter die Adresse des LED Displays mit gegeben.
'
'-----------------------------------------------------------------------
' Der IIC-Bus liegt an PORT 2 (SDA) und PORT 5 (SCL)
'------------------------------------------------------------------------
' BEISPIEL
' Das Beispiel zeigt diverse kurze Mitteilungen und einen laufenden Zhler 
' bis 255 und rdy nach Ablauf des Programms
'---------------------------------------------------------------------
' ACHTUNG:
' Das LED-Display bentigt bei max. Helligkeit sehr viel Strom
' Die Khlung des Spannungsreglers auf dem Application-Board ist
' dafr nicht ausreichend. Betreiben Sie das Display mit BRIGHT2,
' wenn keine zustzliche Khlung fr den Spannungsregler auf dem
' Application-Board vorgesehen ist.
' BRIGHT0 ist vollstndiege Dunkelheit, die LEDs sind also aus.
'-----------------------------------------------------------------------

'--------------------------
'------ I/O PORTS ---------
'--------------------------
'--- IIC INTERFACE  -------
define SDA      port[2]
define SCL      port[5]
define DATABYTE as byte
'---------------------------
define TAUSENDER   as byte
define HUNDERTER   as byte
define ZEHNER      as byte
define EINER       as byte
define TEMP        as byte
'-------------------------




const ADDR = 118
import "....\LIB\MICRO_IIC_GENERIC.BAS"
import "....\LIB\MICRO_IIC_LED_DRIVE.BAS"

'------------------------------------------------------

'----------------------------------------------------
'          SPLIT VALUE INTO DIGITS
'----------------------------------------------------
FUNCTION SPLIT_DIGITS(VALUE as byte)
HUNDERTER=VALUE/100
ZEHNER=(VALUE-(HUNDERTER*100))/10
EINER=VALUE-HUNDERTER*100-ZEHNER*10 
END FUNCTION
'----------------------------------------------------

#MAIN
define COUNTER as byte

'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'III      DEMO MESSAGES AND COUNTERS                   II
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
                       
'----------- TEST - ALL SEGMENTS ON --------------------
SHOW_TEST(ADDR)
pause 50
'----------- BLANK - ALL SEGMENTS OFF ------------------
SHOW_BLANK(ADDR)
pause 50
'----------- SHOW IDLE MESSAGE ----------------------------
SHOW_IDLE(ADDR)
pause 50
'----------- SHOW IN MESSAGE ----------------------------
SHOW_IN(ADDR)
pause 50
'----------- SHOW OUT MESSAGE ---------------------------
SHOW_OUT(ADDR)
pause 50
'----------- SHOW CLEAR MESSAGE -------------------------
SHOW_CLEAR(ADDR)
pause 50
'----------- SHOW ERROR MESSAGE -------------------------
SHOW_ERROR(ADDR)
pause 50
'----------- SHOW ON MESSAGE ----------------------------
SHOW_ON(ADDR)
pause 50
'----------- SHOW OFF MESSAGE ---------------------------
SHOW_OFF(ADDR)
pause 50 
'---------- SHOW RUNNING COUNTER ------------------------
for COUNTER=0 to 255
SPLIT_DIGITS(COUNTER)
DECODE(EINER)
EINER=TEMP
DECODE(ZEHNER)
ZEHNER=TEMP
DECODE(HUNDERTER)
HUNDERTER=TEMP
TAUSENDER=0
SENDBUF(ADDR,BRIGHT1,EINER,ZEHNER,HUNDERTER,TAUSENDER)
next
'--------- FLASHING READY -------------------------------
#RDY
SHOW_READY(ADDR)
pause 20
SHOW_BLANK(ADDR)
pause 20
goto RDY
end'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII

  

attributes
             
         
        
       
      
     
    
    
  
     
end attributes
