'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'IIII     BASIC++    DEMO ZUR MICRO - SYSTEMERWEITERUNG -       IIIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'
'--------------------------------------------------------------------
' ERWEITERUNG:    BASIC-SYSTEMERWEITERUNG DCF-SYNCHRONISATION       -
'                 RXD                                               -
'--------------------------------------------------------------------
' Diese Demo ladet die BASIC-SYSTEMERWEITERUNG "PAGE0_EXT1.S19"
' und zeigt wie die RTC der MICRO mit einer DCF-Uhr synchronisiert wird.
' Der Aufruf SYS  DCFSYNC startet die Synchronisation, die nach ca. 2 Minuten
' abgeschlossen ist.
' Zur Kontrolle wird ber die serielle Schnittstelle der Inhalt der RTC ausgegeben
' and mit LED 5 die Pulse am DCF-Eingang sichtbar gemacht.
' Mit dieser Erweiterung wird auch der Befehl RXD freigeschaltet der anzeigt, ob
' die Uhrzeit Synchronisiert ist.
' Verwendet wird er z.B. so:
'
' if RXD then goto SYNC
' if NOT RXD then goto UNSYNC

' In unserem Beispiel wird der BEEPER aktiviert wenn die Uhrzeit synchronisiert ist.
' Nach der Synchronisation luft die Uhrzeit mit RTC-Genauigkeit weiter, sodass
' Sie SYS DCFSYNC entsprechend den Anforderungen an die Genauigkeit der RTC hufiger
' aufrufen mssen.
' Wenn die RTC einmal synchronisiert ist, wird der Interrupt abgeschaltet und muss fr
' eine erneute Synchronisaton mit SYS DCFSYNC aktiviert werden.
' Gleichzeitig wir damit RXD auf false gesetzt und erst wieder true, wenn die Uhr
' erneut synchron ist.

' EINSCHRNKUNGEN:
' Die DCF Synchronisation betrifft nur die Uhrzeit. Datum und Wochentag werden
' nicht synchronisiert, da hierfr im System keine Variablen vorgesehen sind.
' Bentigen Sie in Ihrer Anwendung das Datum, so knnen sie dieses mit einem
' kleinen Unterprogramm erzeugen und in den Variablen ablegen.
'  !! Die Synchronisation beeinhaltet keine Korrektur von bertragungsfehlern !!
' Wenn Sie die Uhreit hundertprozentig sicher anzeigen zu wollen, mssen Sie
' fr eine Verifizierung mehrer Rahmen selbst Sorge tragen.
'
'
' ACHTUNG:
' Das Treiberprogramm luft interruptgesteuert im Hintergrund, auf der
' SYSCODE PAGE 0
' Deswegen verringert sich die max. Lnge des nutzbaren Basicbereiches um 256 Bytes
' also auf 1792 Bytes. Als Benutzer mssen Sie selbst darauf achten, dass durch ein
' berlanges BASIC-Programm der Maschinencode auf Page0 nicht berschrieben wird.
' Der SYSCODE muss nur ein einziges Mal geladen werden. Er verbleibt dann resident
' im Speicher.
' Das angeschlossene DCF-Uhrenmodul muss whrend der Sekundenimpulse von HI auf LO tasten.
'
'-----------------------------------------------------------------------
' SIE DRFEN DIESEN TREIBER NUR LADEN, WENN DIE PAGE0/1 NICHT VON ANDEREN
' TREIBERN/SYSTEMERWEITERUNGEN, DIE SIE BENTIGEN, BELEGT IST !
' Der Treiber ist nicht fr die MICRO mit der OS-Version 2.00 geeignet
'---------------------------------------------------------------------
'--------------------------
'------ I/O PORTS ---------
'--------------------------
define DCFIN    port[4]
define TASTER   port[3]
define LED      port[5]
define BEEPER   port[6]
'--------------------------
'---- SYSTEM MEMORY -------
'--------------------------
define OLD_SEC      byte[1]
define  a           byte[2]
'--------------------------
'---- SYSTEM JUMPS  -------
'--------------------------
const DCFSYNC=FD09h


SYS DCFSYNC
'------- DIE UHR EINSTELLEN ---------------------
LED=on
HOUR=0
MINUTE=0
SECOND=0
baud R9600
pause 5
print"START"
'--------------------------------------------------
'        SYNCHRONIZE THE RTC WITH DCF77           -
'--------------------------------------------------

#TICKING
IF DCFIN=off then LED=on
if DCFIN=on then LED=off
if OLD_SEC = second then goto TICKING

#BLINK
OLD_SEC=second
print HOUR;
print":";
print MINUTE;
print ":";
print SECOND
if RXD then beep 100,5,BEEPER
goto TICKING




syscode "page0_ext1.s19"


attributes
ccproject                   
  
end attributes
